%Do cross-validation to choose sigma and lambda for LSQMI

Z = W*X;

[Cz, ZC_diff, ZC_dist, CzCz_dist] = Z_gen(Z,cindz);

CV_VALUES = zeros(length(sigma_list2), length(lambda_list2), FOLDNUM);

for sigma_index = 1 : length(sigma_list2)
	sigma = sigma_list2(sigma_index);
	
	H_cv = ((sqrt(pi)*sigma)^(dz+dy))*exp(-(CzCz_dist+CyCy_dist)/(4*sigma^2));

	GauZ2D = exp(-ZC_dist/(2*sigma^2));
	GauY2D = exp(-YC_dist/(2*sigma^2)); %[b n]

	for ii = 1 : FOLDNUM

		hz_train = GauZ2D(:,cv_index(cv_split~=ii));
		hy_train = GauY2D(:,cv_index(cv_split~=ii));
		h_train = mean(hz_train.*hy_train, 2) - mean(hz_train, 2).*mean(hy_train,2);
		
		hz_test = GauZ2D(:,cv_index(cv_split==ii));
		hy_test = GauY2D(:,cv_index(cv_split==ii));
		h_test = mean(hz_test.*hy_test, 2) - mean(hz_test, 2).*mean(hy_test,2);
		
		
		for lambda_index = 1 : length(lambda_list2)
			lambda = lambda_list2(lambda_index); 

			%theta = (H_cv + lambda*Ib)\(h_train);
			theta = mylinsolve(H_cv + lambda*Ib, h_train);

			val = theta'*H_cv*theta/2 - theta'*h_test;

			CV_VALUES(sigma_index, lambda_index, ii) = val;
		end
	end
end

[score_cv_tmp,lambda_index]=min(mean(CV_VALUES, 3), [], 2);
[dummy,sigma_index]=min(score_cv_tmp);
lambda = lambda_list2(lambda_index(sigma_index));
sigma = sigma_list2(sigma_index);


	
