%Do cross-validation to choose sigma and lambda for LSQMID

Z = W*X;
[Cz, ZC_diff, ZC_dist, CzCz_dist] = Z_gen(Z,cindz);

% cv for each dimension
sigma_dz = zeros(dz, 1);    %storage
lambda_dz = zeros(dz, 1);   %storage
for l = 1 : dz
    CV_VALUES = zeros(length(sigma_list), length(lambda_list), FOLDNUM);
    CV_VALUES_1 = zeros(length(sigma_list), length(lambda_list), FOLDNUM);
    CV_VALUES_2 = zeros(length(sigma_list), length(lambda_list), FOLDNUM);
    
    Cz_l = Cz(l, :);
    Cz_lk = repmat(Cz_l, [b 1]) + repmat(Cz_l, [b 1])';
    CzZ_l = permute(ZC_diff(:, :, l), [1 2 3]);  %(Cz - Z)_l (a matrix [b n])
    
    for sigma_index = 1 : length(sigma_list)
        sigma = sigma_list(sigma_index);
             
        tmp_H = (Cz_l'*Cz_l) - (Cz_lk.*Cz_lk/2) + (Cz_lk/2).^2 + (sigma^2)/2;
		H_tt = ((sqrt(pi)*sigma)^(dz+dy))*exp(-(CzCz_dist+CyCy_dist)/(4*sigma^2))/sigma^4;
        H_cv = H_tt .* tmp_H;
        
        GauZ2D = exp(-ZC_dist/(2*sigma^2));
        GauY2D = exp(-YC_dist/(2*sigma^2)); %[b n]
        
        for ii = 1 : FOLDNUM
            
            %for Cz
			hz_train = GauZ2D(:,cv_index(cv_split~=ii));
            hz_train_f = (CzZ_l(:, cv_index(cv_split~=ii)).^2) .* hz_train ;
            hz_train_l = hz_train;
            hy_train = GauY2D(:,cv_index(cv_split~=ii));
            
            h1_train = mean(hz_train_f.*hy_train, 2)/sigma^4 - mean(hz_train_l.*hy_train, 2)/sigma^2;
            h2_train = mean(hz_train_f, 2).*mean(hy_train, 2)/sigma^4 - mean(hz_train_l, 2).*mean(hy_train, 2)/sigma^2;
            
			hz_test = GauZ2D(:,cv_index(cv_split==ii));
            hz_test_f = (CzZ_l(:, cv_index(cv_split==ii)).^2) .* hz_test;
            hz_test_l = hz_test;
            hy_test = GauY2D(:,cv_index(cv_split==ii));
            
            h1_test = mean(hz_test_f.*hy_test, 2)/sigma^4 - mean(hz_test_l.*hy_test, 2)/sigma^2;
            h2_test = (mean(hz_test_f, 2).*mean(hy_test, 2))/sigma^4 - mean(hz_test_l, 2).*mean(hy_test, 2)/sigma^2;
            
			for lambda_index = 1 : length(lambda_list)
				lambda = lambda_list(lambda_index); 

				%theta = -((H_cv + lambda*Ib)\(h1_train - h2_train));
				theta = -mylinsolve(H_cv + lambda*Ib, h1_train - h2_train);
				
				%val = (theta'*H_cv*theta/2 + theta'*(h1_test - h2_test));
				val_1 = theta'*H_cv*theta/2;
				val_2 = theta'*(h1_test - h2_test);

				%CV_VALUES(sigma_index, lambda_index, ii) = val;
				CV_VALUES_1(sigma_index, lambda_index, ii) = val_1;
				CV_VALUES_2(sigma_index, lambda_index, ii) = val_2;
				CV_VALUES(sigma_index, lambda_index, ii) = val_1 + val_2;
			end
        end
	end
	
	[score_cv_tmp,lambda_index]=min(mean(CV_VALUES, 3), [], 2);
	[dummy,sigma_index]=min(score_cv_tmp);
	lambda_dz(l) = lambda_list(lambda_index(sigma_index));
	sigma_dz(l) = sigma_list(sigma_index);

end
