%compute LSQMID with for fixed point iteration

dQMI = zeros(dz, dx);
QMI_AZ = zeros(dz, 1);

F1 = zeros(dz, dx);
F2 = zeros(dz, dx);
F3 = zeros(dz, dx);

Z = W*X;
[Cz, ZC_diff, ZC_dist, CzCz_dist] = Z_gen(Z,cindz);
    
for l = 1 : dz

	sigma = sigma_dz(l);
	lambda = lambda_dz(l);
	
	GauZ2D = exp(-ZC_dist/(2*sigma^2));
	GauY2D = exp(-YC_dist/(2*sigma^2)); %[b n]
	mGauY2D = mean(GauY2D, 2);
	GauZ3D = permute(repmat(GauZ2D, [1, 1, dx]), [1, 3, 2]);  %[b n dx] --> [b dx n]
	GauY3D = permute(repmat(GauY2D, [1, 1, dx]), [1, 3, 2]);  %[b n dx] --> [b dx n]

    Cz_l = Cz(l, :);
    Cz_lk = repmat(Cz_l, [b 1]) + repmat(Cz_l, [b 1])';
    CzZ_l = permute(ZC_diff(:, :, l), [1 2 3]);  %(Cz - Z)_l (a matrix [b n])
    
    %Stored Matrices
    tmp_H = (Cz_l'*Cz_l) - (Cz_lk.*Cz_lk/2) + (Cz_lk/2).^2 + (sigma^2)/2;
	H_tmp2 = (sqrt(pi)*sigma)^(dz+dy)*exp(-(CzCz_dist+CyCy_dist)/(4*sigma^2))/sigma^4;
    Hhat = H_tmp2 .* tmp_H ;
    
    hz_f = (CzZ_l.^2).*GauZ2D;
    h1 = mean(hz_f.*GauY2D, 2)/sigma^4 - (mean(GauZ2D.*GauY2D, 2))/sigma^2;
    h2 = (mean(hz_f, 2).*mGauY2D)/sigma^4 - (mean(GauZ2D, 2).*mGauY2D)/sigma^2;
    
    hhat = h1 - h2;
    
    %theta = -(Hhat+lambda*Ib)\hhat;
    theta = -mylinsolve(Hhat+lambda*Ib, hhat);
	
	%for dQMI	
	ZC_diff3D = permute(repmat(ZC_diff(:,:,l), [1,1,dx]), [1, 3, 2]);
	
	q1 = mean(ZC_diff3D.*GauZ3D.*GauY3D.*Xl3d, 3);	%[b dx]
	q2 = mean(ZC_diff3D.*GauZ3D.*Xl3d, 3).*mean(GauY3D, 3);	%[b dx]
	dQMI(l,:) = theta'*(q1-q2);
	
	%%F1 is not used for the gradient update formulation
    %Cz_l3D = permute(repmat(Cz_l', [1, n, dx]), [1, 3, 2]);     %[b n dx] --> [b dx n] (C)
    %F1(l,:) = theta'*(mean(Cz_l3D.*GauZ3D.*GauY3D.*Xl3d, 3) ...
    %          - mean(Cz_l3D.*GauZ3D.*Xl3d, 3).*mean(GauY3D, 3));

	for ll = 1 : dx
		tmpXX = repmat(X(ll, :).*X(ll,:), [b, 1]);
		F3(l,ll) = theta'*(mean(GauZ2D.*GauY2D.*tmpXX ,2) - mean(GauZ2D.*tmpXX ,2).*mGauY2D);	
	end
	
	%QMI_AZ(l, 1) = (theta'*(mean(GauZ2D.*GauY2D, 2) - mean(GauZ2D, 2).*mGauY2D))/2;
end

%QMI_A = mean(QMI_AZ);		%QMI_AZ is only valid for dz = 1

%F2 = F1 - W.*F3 - dQMI;	%F2 is not used for the gradient update formulation



